SystemOrganization addCategory: #'ROS-Core'!
SystemOrganization addCategory: #'ROS-TCPROS'!
SystemOrganization addCategory: #'ROS-TCPROS-Tests'!
SystemOrganization addCategory: #'ROS-Core-Tests'!

!String methodsFor: '*ROS' stamp: 'SergeStinckwich 6/7/2012 11:23'!
asROSGraphName
	^ ROSGraphName with: self! !

TestCase subclass: #ROSGraphNameTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ROS-Core-Tests'!

!ROSGraphNameTest methodsFor: 'tests' stamp: 'SergeStinckwich 6/7/2012 11:20'!
testCanonicalizeName
	self assert: '' equals: '' asROSGraphName asString.
	self assert: '/' equals: '/' asROSGraphName asString.
	self assert: '/' equals: '//' asROSGraphName asString.
	self assert: '/' equals: '///' asROSGraphName asString.
	self assert: 'foo' equals: 'foo' asROSGraphName asString.
	self assert: 'foo' equals: 'foo/' asROSGraphName asString.
	self assert: 'foo' equals: 'foo//' asROSGraphName asString.
	self assert: '/foo' equals: '/foo' asROSGraphName asString.
	self assert: '/foo' equals: '/foo/' asROSGraphName asString.
	self assert: '/foo' equals: '/foo//' asROSGraphName asString.
	self assert: '/foo/bar' equals: '/foo/bar' asROSGraphName asString.
	self assert: '/foo/bar' equals: '/foo/bar/' asROSGraphName asString.
	self assert: '/foo/bar' equals: '/foo/bar///' asROSGraphName asString.
	self assert: '~foo' equals: '~foo' asROSGraphName asString.
	self assert: '~foo' equals: '~foo/' asROSGraphName asString.
	self assert: '~foo' equals: '~foo//' asROSGraphName asString.
	self assert: '~foo' equals: '~/foo' asROSGraphName asString! !

!ROSGraphNameTest methodsFor: 'tests' stamp: 'SergeStinckwich 6/7/2012 11:20'!
testInvalidNames
	| illegalChars illegalNames |
	illegalChars := #($= $- $( $) $* $% $^).
	illegalChars do: [ :each | self should: [ ('good' , each asString) asROSGraphName ] raise: Error ].
	illegalNames := #('/~private' '5foo').
	illegalNames do: [ :each | self should: [ each asROSGraphName ] raise: Error ]! !

!ROSGraphNameTest methodsFor: 'tests' stamp: 'SergeStinckwich 6/7/2012 11:22'!
testIsGlobal
	| validCases invalidCases |
	validCases := #('/' '/global' '/global2').
	validCases do: [ :each | self assert: each asROSGraphName isGlobal ].
	invalidCases := #('' 'not_global' 'not/global').
	invalidCases do: [ :each | self assert: each asROSGraphName isGlobal not ]! !

!ROSGraphNameTest methodsFor: 'tests' stamp: 'SergeStinckwich 6/7/2012 11:31'!
testIsPrivate
	| validCases invalidCases |
	validCases := #('~name' '~name/sub').
	validCases do: [ :each | self assert: each asROSGraphName isPrivate ].
	invalidCases := #('' 'not_private' 'not/private' '/').
	invalidCases do: [ :each | self assert: each asROSGraphName isPrivate not ]! !

!ROSGraphNameTest methodsFor: 'tests' stamp: 'SergeStinckwich 6/7/2012 11:31'!
testIsRelative
	self assert: 'name' asROSGraphName isRelative.
	self assert: '/name' asROSGraphName isRelative not! !

!ROSGraphNameTest methodsFor: 'tests' stamp: 'SergeStinckwich 6/7/2012 11:31'!
testParentOfEmptyIsEmpty
	| empty |
	empty := '' asROSGraphName.
	self assert: empty equals: empty parent! !

!ROSGraphNameTest methodsFor: 'tests' stamp: 'SergeStinckwich 6/7/2012 11:31'!
testParentOfGlobalIsGlobal
	| global |
	global := ROSNamespace global.
	self assert: global equals: global asROSGraphName parent asString! !

!ROSGraphNameTest methodsFor: 'tests' stamp: 'SergeStinckwich 6/7/2012 11:32'!
testParentOfGlobalNames
	self assert: '/wg' asROSGraphName equals: '/wg/name' asROSGraphName parent.
	self assert: '/wg' asROSGraphName equals: '/wg/name/' asROSGraphName parent.
	self assert: '/' asROSGraphName equals: '/wg/' asROSGraphName parent.
	self assert: '/' asROSGraphName equals: '/wg' asROSGraphName parent! !

!ROSGraphNameTest methodsFor: 'tests' stamp: 'SergeStinckwich 6/7/2012 11:32'!
testParentOfRelativeNames
	self assert: 'wg' asROSGraphName equals: 'wg/name' asROSGraphName parent.
	self assert: '' asROSGraphName equals: 'wg/' asROSGraphName parent! !

!ROSGraphNameTest methodsFor: 'tests' stamp: 'SergeStinckwich 6/7/2012 11:32'!
testToString
	| canonicalNames |
	canonicalNames := #('abc' 'ab7' '/abc' '/abc/bar' '/' '~garage' '~foo/bar').
	canonicalNames do: [ :each | self assert: each equals: each asROSGraphName asString ].
	self assert: '' equals: '' asROSGraphName asString.
	self assert: '/' equals: '/' asROSGraphName asString.
	self assert: '/foo' equals: '/foo/' asROSGraphName asString.
	self assert: 'foo' equals: 'foo/' asROSGraphName asString.
	self assert: 'foo/bar' equals: 'foo/bar/' asROSGraphName asString! !

TestCase subclass: #ROSNodeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ROS-Core-Tests'!

!ROSNodeTest methodsFor: 'tests' stamp: 'SergeStinckwich 6/7/2012 10:48'!
testName

|node1|
  node1 := ROSNode on:'/test_up_down'.
  self assert: node1 nodeName equals:'/test_up_down'! !

!ROSNodeTest methodsFor: 'tests' stamp: 'SergeStinckwich 6/7/2012 12:23'!
testNodeAfterShutdownIsNotRunning


|node1|
	node1 := ROSNode on: '/test_up_down'.
	node1 shutDown.
	self assert: node1 isOk not! !

!ROSNodeTest methodsFor: 'tests' stamp: 'SergeStinckwich 6/7/2012 12:22'!
testNodeIsOk


|node1|
  node1 := ROSNode on: '/test_up_down'.
  self assert: node1 isOk! !

TestCase subclass: #TCPROSHeaderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ROS-TCPROS-Tests'!

!TCPROSHeaderTest methodsFor: 'tests' stamp: 'SergeStinckwich 5/27/2012 22:43'!
testDeserializeHeader

| h |
h := TCPROSHeader new.
h deserialize: #[8 0 0 0 4 0 0 0 97 97 61 53].
self assert: (h at:'aa' = 5)! !

!TCPROSHeaderTest methodsFor: 'tests' stamp: 'SergeStinckwich 5/27/2012 18:09'!
testHeaderKeysAndValuesAreString

| h |
h := TCPROSHeader new.

self shouldnt: [h at: 'aa' put: '5'] raise: Error.
self should: [h at: 1 put: 2] raise: Error! !

!TCPROSHeaderTest methodsFor: 'tests' stamp: 'SergeStinckwich 5/27/2012 18:10'!
testHeaderWorksAsADictionnary

| h |
h := TCPROSHeader new.
h at: 'aa' put: '5'.

self assert: (h at:'aa') equals:'5'! !

!TCPROSHeaderTest methodsFor: 'tests' stamp: 'SergeStinckwich 5/27/2012 22:39'!
testSerializeHeader

| h |
h := TCPROSHeader new.
h at: 'aa' put: '5'.

self assert: (h serialize = #[8 0 0 0 4 0 0 0 97 97 61 53])! !

!Integer methodsFor: '*ROS' stamp: 'SergeStinckwich 5/27/2012 22:32'!
as32bitsUnsignedLittleEndian
	| bytes | 
	bytes := ByteArray new: 4.
	self > 0
		ifTrue: [bytes
				at: 4
				put: (self bitShift: -24)]
		ifFalse: [bytes at: 4 put: ((self bitShift: -24) negated)].
	bytes at: 1 put: self \\ 256.
	bytes at: 2 put: (self bitShift: -8)
			\\ 256.
	bytes at: 3 put: (self bitShift: -16)
			\\ 256.
	^ bytes! !

Error subclass: #ROSNameException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ROS-Core'!

Object subclass: #ROSGraphManager
	instanceVariableNames: 'publishers subscribers serviceServers parameterSubscribers host port isOk'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ROS-Core'!

!ROSGraphManager commentStamp: '<historical>' prior: 0!
Manager of ROS graph

 this contains all subscribers, publishers, service_servers of a node.
 Master API document is http://ros.org/wiki/ROS/Master_API
 Slave API is http://ros.org/wiki/ROS/Slave_API!

!ROSGraphManager methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 6/7/2012 12:20'!
initialize

isOk := true. "I'm running"! !

!ROSGraphManager methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 6/7/2012 12:20'!
isOk

^isOk! !

!ROSGraphManager methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 6/7/2012 12:25'!
shutDown

isOk := false.! !

Object subclass: #ROSGraphName
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ROS-Core'!

!ROSGraphName commentStamp: '<historical>' prior: 0!
ROS Graph Name

http://ros.org/wiki/Names#Names-1!

!ROSGraphName class methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 6/7/2012 11:24'!
with: aString
	^ super new initialize: aString! !

!ROSGraphName methodsFor: 'comparing' stamp: 'SergeStinckwich 6/7/2012 11:26'!
= aROSGraphName
	^ name = aROSGraphName asString! !

!ROSGraphName methodsFor: 'converting' stamp: 'SergeStinckwich 6/7/2012 11:30'!
asString
	^ name! !

!ROSGraphName methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 6/7/2012 11:26'!
canonicalizeName
	[ name ~= ROSNamespace global & (name endsWith: '/') ] whileTrue: [ name := name allButLast ].
	(name beginsWith: '~/')
		ifTrue: [ name := '~' , (name copyFrom: 3 to: name size) ]! !

!ROSGraphName methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 6/7/2012 11:25'!
initialize: aString
	name := aString.
	self validate.
	self canonicalizeName! !

!ROSGraphName methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 6/7/2012 11:26'!
isGlobal
	^ name beginsWith: '/'! !

!ROSGraphName methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 6/7/2012 11:26'!
isPrivate
	^ name beginsWith: '~'! !

!ROSGraphName methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 6/7/2012 11:26'!
isRelative
	^ self isPrivate not and: [ self isGlobal not ]! !

!ROSGraphName methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 6/7/2012 11:27'!
parent
	| newName |
	name isEmpty
		ifTrue: [ ^ '' asROSGraphName ].
	name = ROSNamespace global
		ifTrue: [ ^ ROSNamespace global asROSGraphName ].
	newName := name copyUpToLast: $/.
	newName = name
		ifTrue: [ ^ '' asROSGraphName ].
	newName size > 1
		ifTrue: [ ^ newName asROSGraphName ].
	self isGlobal
		ifTrue: [ ^ ROSNamespace global asROSGraphName ]
		ifFalse: [ ^ '' asROSGraphName ]! !

!ROSGraphName methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 6/7/2012 11:27'!
validRosNamePattern
	^ '(/|~|[A-Za-z])([0-9a-zA-Z]|_|/)*'! !

!ROSGraphName methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 6/7/2012 11:36'!
validate
	name isEmpty not
		ifTrue: [ 
			(name matchesRegex: self validRosNamePattern) not
				ifTrue: [ ROSNameException signal: 'Invalid unix name, may not contain special characters.' ] ].
	^ true! !

Object subclass: #ROSNamespace
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ROS-Core'!

!ROSNamespace class methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 6/7/2012 11:28'!
global
	^ '/'! !

Object subclass: #ROSNode
	instanceVariableNames: 'host nodeName remappings manager masterURI rosNamespace'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ROS-Core'!

!ROSNode class methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 6/7/2012 12:15'!
anonymous

^super new! !

!ROSNode class methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 6/7/2012 10:48'!
on: aString

^ (super new) nodeName: aString! !

!ROSNode methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 6/7/2012 12:14'!
getEnvironmentVariables

| rosIP |
masterURI := OSProcess thisOSProcess environmentAt: 'ROS_MASTER_URI'.
rosNamespace := OSProcess thisOSProcess environmentAt: 'ROS_NAMESPACE'.
rosIP := OSProcess thisOSProcess environmentAt: 'ROS_IP'.
rosIP isNil
		ifTrue:[host := OSProcess thisOSProcess environmentAt: 'ROS_IP'.]
		ifFalse:[OSProcess thisOSProcess environmentAt: 'ROS_NAMESPACE'.]! !

!ROSNode methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 6/7/2012 10:49'!
getHost

! !

!ROSNode methodsFor: 'initialize-release' stamp: 'SergeStinckwich 6/7/2012 12:21'!
initialize 

manager := ROSGraphManager new.
remappings := Dictionary new.
host := self getHost.

self getEnvironmentVariables! !

!ROSNode methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 6/7/2012 10:50'!
isOk

^manager isOk! !

!ROSNode methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 5/27/2012 23:04'!
nodeName

^nodeName! !

!ROSNode methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 6/7/2012 10:47'!
nodeName: aString

nodeName := aString! !

!ROSNode methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 6/7/2012 10:59'!
resolveName! !

!ROSNode methodsFor: 'initialize-release' stamp: 'SergeStinckwich 6/7/2012 12:24'!
shutDown

self isOk ifTrue:[
manager shutDown]! !

Object subclass: #ROSTopicManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ROS-Core'!

!ROSTopicManager class methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 6/7/2012 11:45'!
on:aString

^ super new! !

Object subclass: #TCPROSClient
	instanceVariableNames: 'callerId topicName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ROS-TCPROS'!

!TCPROSClient methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 6/1/2012 18:19'!
buildHeader! !

!TCPROSClient methodsFor: 'initialize-release' stamp: 'SergeStinckwich 6/1/2012 18:20'!
initialize 

| header |
header := TCPROSHeader new.

^ header! !

Object subclass: #TCPROSHeader
	instanceVariableNames: 'data'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ROS-TCPROS'!

!TCPROSHeader commentStamp: '<historical>' prior: 0!
More information here: http://www.ros.org/wiki/ROS/Connection%20Header!

!TCPROSHeader methodsFor: 'initialize-release' stamp: 'SergeStinckwich 5/27/2012 17:34'!
at:aKey

^ data at:aKey! !

!TCPROSHeader methodsFor: 'initialize-release' stamp: 'SergeStinckwich 5/27/2012 17:59'!
at: aKey put: aValue

(aKey isString and: (aValue isString)) ifTrue:[
data at:aKey put: aValue]
ifFalse:[self error:'header key and value must be string']! !

!TCPROSHeader methodsFor: 'initialize-release' stamp: 'SergeStinckwich 5/27/2012 22:43'!
deserialize: aBinaryArray 
! !

!TCPROSHeader methodsFor: 'initialize-release' stamp: 'SergeStinckwich 5/27/2012 17:39'!
initialize 

data := Dictionary new
! !

!TCPROSHeader methodsFor: 'initialize-release' stamp: 'SergeStinckwich 5/27/2012 22:38'!
serialize 

| bytes |
bytes := #[].

data keysAndValuesDo: [:key :value| |s| 
	s := key, '=', value.
	bytes := bytes, (s size as32bitsUnsignedLittleEndian), s asByteArray.
	].
bytes := bytes size as32bitsUnsignedLittleEndian, bytes.
^ bytes! !

Object subclass: #TCPROSMessage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ROS-TCPROS'!

!TCPROSMessage methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 5/25/2012 17:46'!
protocol
	^#TCPROS! !

!TCPROSMessage methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 5/25/2012 17:47'!
readAllFrom:aSocket! !

!TCPROSMessage methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 5/25/2012 17:47'!
readHeaderFrom:aSocket! !

!TCPROSMessage methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 5/25/2012 17:46'!
write:aMsg on:aSocket! !

!TCPROSMessage methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 5/25/2012 17:47'!
writeHeaderFrom:aSocket! !

Object subclass: #TCPROSServer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ROS-TCPROS'!
